{*************************************************

  Super Lock Label Data Aware v1.2 by Andrew J. McGee
  E-Mail: jaym25@3ptech.com
  Last Revision Date: 12/22/97

  Copyright (c) 1997 by Andrew J. McGee
  This Source Code may not be distributed to any other person
  without the express written permission of the Author

  The Author may also be contacted via snail mail:
     PO Box 80336
     Baton Rouge, LA 70898 USA

  This unit overrides the CheckCaption procedure in SLockLabel.
  By expanding this procedure or creating it in another derived
  control, you can customize the the behavior of the SLockLabel
  caption to meet your own individual requirements.

***************************************************}
unit SLkLblDB;

{$A+,B-,G+,H+,O+,J-,T+,U-,V+,W-,X+} //Set up compiler
{$D-,L-,Q-,R-,Y-} //Comment out to debug

{$define Delphi3} //For Delphi 3 - Comment out for Delphi 2

interface

uses
  SLockLbl, Controls, Classes, DBCtrls;

type
  TDBSLockLabel = class(TSLockLabel)
  private
      FUseDisplayLabel: Boolean;
  protected
    constructor Create(Aowner: TComponent); override;
    procedure CheckCaption; override;
  public
  published
    property UseDisplayLabel: Boolean read FUseDisplayLabel
     write FUseDisplayLabel default True;
end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Data Controls', [TDBSLockLabel]);
end;

{ DBSLockLabel }

constructor TDBSLockLabel.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FUseDisplayLabel:=True;
end;

procedure TDBSLockLabel.CheckCaption;
begin
  if not FUseDisplayLabel then exit;
  if(FocusControl is TDBEdit)and
   Assigned(TDBEdit(FocusControl).Field)then begin
    Caption:=TDBEdit(FocusControl).Field.DisplayName; exit; end;
  if FocusControl is TDBMemo and
   Assigned(TDBMemo(FocusControl).Field)then begin
    Caption:=TDBMemo(FocusControl).Field.DisplayName; exit; end;
  if FocusControl is TDBCheckBox and
   Assigned(TDBCheckBox(FocusControl).Field)then begin
    Caption:=TDBCheckBox(FocusControl).Field.DisplayName; exit; end;
  if FocusControl is TDBComboBox and
   Assigned(TDBComboBox(FocusControl).Field)then begin
    Caption:=TDBComboBox(FocusControl).Field.DisplayName; exit; end;
  if FocusControl is TDBListBox and
   Assigned(TDBListBox(FocusControl).Field)then begin
    Caption:=TDBListBox(FocusControl).Field.DisplayName; exit; end;
  if FocusControl is TDBRadioGroup and
   Assigned(TDBRadioGroup(FocusControl).Field)then begin
    Caption:=TDBRadioGroup(FocusControl).Field.DisplayName; exit; end;
  if FocusControl is TDBImage and
   Assigned(TDBImage(FocusControl).Field)then begin
    Caption:=TDBImage(FocusControl).Field.DisplayName; exit; end;
{$ifdef Delphi3}
  if FocusControl is TDBRichEdit and
   Assigned(TDBRichEdit(FocusControl).Field)then begin
    Caption:=TDBRichEdit(FocusControl).Field.DisplayName; exit; end;
  if FocusControl is TDBLookupControl and
   Assigned(TDBLookupControl(FocusControl).Field)then begin
    Caption:=TDBLookupControl(FocusControl).Field.DisplayName; exit; end;
{$endif}
end;

end.